name: Build Windows

on: [push]

jobs:
  windows:
    name: Build & Test
    runs-on: windows-2022
    env:
      PLATFORM: x64
      WIRESHARK_BASE_DIR: C:\Development
      CMAKE_PREFIX_PATH: D:\a\wireshark\Qt\6.2.3\msvc2019_64
      WIRESHARK_VERSION_EXTRA: -GithubActionBuild
    steps:
      - name: Checkout
        uses: actions/checkout@v3
      - name: Choco install
        run: cinst -y --force --no-progress asciidoctorj xsltproc docbook-bundle cmake nsis
      - name: Install winflexbison3
        run: cinst -y --force winflexbison3 --version 2.5.18.20190508
      - name: Install strawberryperl
        uses: shogo82148/actions-setup-perl@v1
        with:
          perl-version: '5.30'
          distribution: strawberry
      - name: Install Qt
        uses: jurplel/install-qt-action@v3
        with:
          arch: win64_msvc2019_64
          version: 6.2.3
          modules: 'qt5compat'
      - name: Add msbuild to PATH
        uses: microsoft/setup-msbuild@v1.1
        with:
          vs-version: 16.8
      - name: Set MSVC command prompt
        uses: ilammy/msvc-dev-cmd@v1
      - name: Mkdir
        run: mkdir build
      - name: Cmake
        run: cmake -DCMAKE_SYSTEM_VERSION="10.0.20348.0" -A x64 ..
        env:
          PLATFORM: x64
          WIRESHARK_BASE_DIR: C:/wireshark-libs
          QT5_BASE_DIR: C:/Qt/5.12.3/msvc2017_64
        working-directory: build
      - name: Build
        run: cmake --build . --config RelWithDebInfo
        working-directory: build
      - name: Build guides
        run: cmake --build . --config RelWithDebInfo --target user_guide_html
        working-directory: build
      - name: Build test-programs
        run: cmake --build . --config RelWithDebInfo --target test-programs
        working-directory: build
      - name: Set up Python 3.8
        uses: actions/setup-python@v4
        with:
          python-version: 3.8
      - name: Install pytest
        run: pip install pytest pytest-xdist
      - name: Run tests
        env:
          PYTEST_ADDOPTS: --skip-missing-programs=rawshark
        run: pytest
        working-directory: build
      - name: Build Windows pkg
        run: |
          msbuild /m /p:Configuration=RelWithDebInfo wireshark_nsis_prep.vcxproj
          msbuild /m /p:Configuration=RelWithDebInfo wireshark_nsis.vcxproj
        working-directory: build
      - name: Upload Windows packages
        uses: actions/upload-artifact@v3
        with:
          name: package
          path: build/packaging/nsis/*exe
